import { LanguageClient } from './lang-handler';
import { ProjectConfiguration } from './project-manager';
import { InitializeParams } from './request-type';
import { TypeScriptService, TypeScriptServiceOptions } from './typescript-service';
import { Operation } from 'fast-json-patch';
import { Span } from 'opentracing';
import { Observable } from 'rxjs';
import * as ts from 'typescript';
import { DocumentSymbolParams, Hover, Location, ReferenceParams, TextDocumentPositionParams } from 'vscode-languageserver';
import { FullParams } from '@elastic/lsp-extension';
export declare class ExtendedTypescriptService extends TypeScriptService {
    protected client: LanguageClient;
    protected options: TypeScriptServiceOptions;
    private dependencyManager;
    constructor(client: LanguageClient, options?: TypeScriptServiceOptions);
    protected _initializeFileSystems(): void;
    initialize(params: InitializeParams, span?: Span): Observable<Operation>;
    shutdown(params?: {}, span?: Span): Observable<Operation>;
    private emptyOperation;
    protected _getSourceMapSourceFile(configuration: ProjectConfiguration, fileName: string, span?: Span): ts.SourceFile | undefined;
    textDocumentFull(params: FullParams, span?: Span): Observable<Operation>;
    protected _getHover(params: TextDocumentPositionParams, span?: Span): Observable<Hover>;
    protected _getDefinitionLocations(params: TextDocumentPositionParams, span?: Span, goToType?: boolean): Observable<Location>;
    private convertLocation;
    private convertUri;
    private replaceWorkspaceInDoc;
    private replaceWorkspaceInString;
    private getPackageLocator;
    private getSymbolLocator;
    textDocumentEdefinition(params: TextDocumentPositionParams, span?: Span): Observable<Operation>;
    private getSymbolLocatorFromLocationInformation;
    private getQname;
    private getQnameBySymbolInformation;
    private getFileName;
    private cleanContainerName;
    textDocumentDocumentSymbol(params: DocumentSymbolParams, span?: Span): Observable<Operation>;
    textDocumentReferences(params: ReferenceParams, span?: Span): Observable<Operation>;
}
export declare type ExtendedTypescriptServiceFactory = (client: LanguageClient, options?: TypeScriptServiceOptions) => ExtendedTypescriptService;
