import { Logger } from './logging';
import { InMemoryFileSystem } from './memfs';
export declare class PatchedInMemoryFileSystem extends InMemoryFileSystem {
    private log;
    private readonly rootUri;
    constructor(path: string, logger: Logger);
    readFile(path: string): string;
    add(uri: string, content?: string): void;
    /**
     * @param path file path (both absolute or relative file paths are accepted)
     * @return file's content in the following order (overlay then cache).
     * If there is no such file, returns undefined
     */
    private readFileIfExistsOverwrite;
}
