"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const util_1 = require("../util");
/**
 * Map-based file system that holds map (URI -> content)
 */
class MapFileSystem {
    constructor(files) {
        this.files = files;
    }
    getWorkspaceFiles(base) {
        return util_1.observableFromIterable(this.files.keys()).filter(path => !base || path.startsWith(base));
    }
    getTextDocumentContent(uri) {
        const ret = this.files.get(uri);
        if (ret === undefined) {
            return rxjs_1.Observable.throw(new Error(`Attempt to read not-existent file ${uri}`));
        }
        return rxjs_1.Observable.of(ret);
    }
}
exports.MapFileSystem = MapFileSystem;
//# sourceMappingURL=fs-helpers.js.map